/*

Notice

This software is public domain. It may freely be copied and used in
non-commercial products, assuming proper credit is given to the author, but it
should not be resold.
If you want to use the software for commercial products, contact the author.

This software is provided ``as is'' without warranty of any kind, either
expressed or implied.
The entire risk as to the quality and performance of the software is with you.
Should the software prove defective, you assume the cost of all necessary
servicing, repair or correction.

Please report any bugs in this package.   Although there is no
guarantee, such bugs may be fixed in a future release of the software.

Please send any comments to wass@cs.stanford.edu (Michael Goldwasser)

*/


/********************************************************
 * arrange_debug.h
 *
 * Functions involving debugger tools
 *
 * Author:  Michael Goldwasser
 * Modified:  Jan 1, 1995 --- Original release (Goldwasser)
 *******************************************************/

#ifndef _ARRANGE_DEBUG
#define _ARRANGE_DEBUG

/* Note this is a different flag than above */
/* This one depends on the makefile */
#ifdef ARRANGE_DEBUG

#include "standards.h"
#include "polygon.h"
#include "arrange_type.h"

void Arrange_TestDriver();
void Arrange_Print(struct Arrange*, Polygon_Data_Printer);
void Arrange_Draw_Graphics(struct Arrange*,Boolean);
Boolean Arrange_SanityCheck(struct Arrange*);
#endif /* ARRANGE_DEBUG */

#endif /* _ARRANGE_DEBUG */
