/*

Notice

This software is public domain. It may freely be copied and used in
non-commercial products, assuming proper credit is given to the author, but it
should not be resold.
If you want to use the software for commercial products, contact the author.

This software is provided ``as is'' without warranty of any kind, either
expressed or implied.
The entire risk as to the quality and performance of the software is with you.
Should the software prove defective, you assume the cost of all necessary
servicing, repair or correction.

Please report any bugs in this package.   Although there is no
guarantee, such bugs may be fixed in a future release of the software.

Please send any comments to wass@cs.stanford.edu (Michael Goldwasser)

*/


/********************************************************
 * main.c
 *
 * Driver
 *
 * Author:  Michael Goldwasser, Bruce Romney, Cyprien Goddard
 * Modified:  Jan 1, 1995 --- Original release (authors)
 *******************************************************/

#include <stdio.h>
#include "arrange.h"
#include "standards.h"

/**************************************************************/
/*---   this is all garbage that is necessary for graphics ---*/
Display *dpy = NIL;		/*Display*/

GC     BASIC_COLORS;
XFontStruct *the_font_struct;

/**************************************************************/

Boolean graphics = TRUE;

/*--- special mode for creating graphics without threads ---*/
Boolean show_threads = TRUE;
extern int   debugger_default_size;

/*--- memory debugger variables ---*/
Boolean mem_debug = FALSE;
void*	bug_ptr = NULL;


void identify_user_options(argc, argv)
     int argc;
     char *argv[];
{
   int i;
   char *option, *nextoption;
   
   for (i=1; i<argc; ++i)
     {
	option = argv[i];
	nextoption = (i!=argc-1) ? argv[i+1] : NIL;

	if ((strcmp(option,"-nographics")==0) ||
		 (strcmp(option,"-nog")==0))	  graphics = FALSE;

	else if (strcmp(option,"-size")==0) {
	    debugger_default_size = (atoi(nextoption));
	    i++;
	}

	else if (strcmp(option,"-danny")==0)  show_threads = FALSE;

	else if (strcmp(option,"-mem_debug")==0)  mem_debug = TRUE;

	else if (strcmp(option,"-bug_ptr")==0) {
	    bug_ptr = ((void*) strtoul(nextoption,NULL,0));
	    i++;
	}

	else 
	  printf("Unrecognized option: %s  (ignored)\n", option);
     }
}



main(argc, argv)
  int argc;
  char **argv;
{

    identify_user_options(argc, argv);

    if (graphics) init_arrange_debugger();

    Arrange_TestDriver();

}
