/********************************************************/
/*							*/
/*		     standards.h			*/
/*							*/
/********************************************************/

#ifndef _STANDARDS
#define  _STANDARDS

/*-------------------------------------------------------------*/
/*    Memory Debug Code					       */
/*-------------------------------------------------------------*/

#ifdef  MEMORY_DETOUR
#include "memory_debug.h"

#define MALLOC(s)    malloc__debug(s)
#define FREE(p)      free__debug(p)
#define CALLOC(n,s)  calloc__debug(n,s)

#else

#define MALLOC(s)    malloc(s)
#define FREE(p)      free(p)
#define CALLOC(n,s)  calloc(n,s)

#endif


#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define NIL NULL

#include <X11/Intrinsic.h>

#define BASIC_COLORS red_gc, blue_gc, grey_gc, green_gc, white_gc, \
  black_gc, yellow_gc, violet_gc, orange_gc, lightblue_gc

#define ALLOCATE(type) ((type *)MALLOC(sizeof(type)))
#define ALLOCATE_ARRAY(type, n) ((type *)CALLOC(n, sizeof(type)))

/*-------------------------------------------------------------*/
/*    Define list					       */
/*-------------------------------------------------------------*/
typedef struct Element *List;

/*===============================================================*/
/*=								=*/
/*=		Simple Geometric Structures			=*/
/*=							   	=*/
/*===============================================================*/
/*---------------------------------------------------------*/
/*     Define vector					   */
/*---------------------------------------------------------*/
typedef struct Vector
{
   double x;
   double y;
   double z;
} Vector;


/*-------------------------------------------------------------*/
/*    Define part                                     	       */
/*-------------------------------------------------------------*/
typedef struct Part
{
  int			id;
} Part;


/*-------------------------------------------------------------*/
/*    Define TwoParts					       */
/*-------------------------------------------------------------*/
typedef struct TwoParts
  /* When this structure is used in a polygon's "data" field, the */
  /* convention is that "part1" is blocked by "part2" everywhere  */
  /* except in the polygon in question.	 (see description below)  */
{
    struct Part	*part1;
    struct Part	*part2;
} TwoParts;

#endif
