/*

Notice

This software is public domain. It may freely be copied and used in
non-commercial products, assuming proper credit is given to the author, but it
should not be resold.
If you want to use the software for commercial products, contact the author.

This software is provided ``as is'' without warranty of any kind, either
expressed or implied.
The entire risk as to the quality and performance of the software is with you.
Should the software prove defective, you assume the cost of all necessary
servicing, repair or correction.

Please report any bugs in this package.   Although there is no
guarantee, such bugs may be fixed in a future release of the software.

Please send any comments to wass@cs.stanford.edu (Michael Goldwasser)

*/


/********************************************************
 * traverse.h
 *
 * Sample application which traverses an arrangement
 *
 * Author:  Michael Goldwasser, Bruce Romney
 * Modified:  Jan 1, 1995 --- Original release (authors)
 *******************************************************/

#ifndef _TRAVERSE
#define _TRAVERSE

#include "standards.h"
#include "arrange_type.h"

/*--- To bypass supporting routines/typedefs, compile with    ---*/
/*---   STRIPPED_VERSION being defined by the Makefile.       ---*/

#ifndef STRIPPED_VERSION

#include "strategy.h"
#include "dbg_type.h"

#else  /* STRIPPED_VERSION */

typedef Boolean (*Trap_Callback)();
typedef Boolean (*Vert_Callback)();
typedef struct Assembly Assembly;
typedef struct DBG DBG;

#endif  /* STRIPPED_VERSION */


typedef (*Traversal)(struct Assembly *, struct Arrange *, List,
		     Trap_Callback, Vert_Callback, void*);

void traverse_ndbg(struct Assembly *, struct Arrange *, List,
		   Trap_Callback, Vert_Callback, void*);

void traverse_ndbg_fbf(struct Assembly *, struct Arrange *, List,
		       Trap_Callback, Vert_Callback, void*);


#endif /* _TRAVERSE */
